#ifndef INTERFACE_H
#define INTERFACE_H

#include <pthread.h>

#include <Constants.h>

using namespace std;

class Interface
{
	public:
	Interface();
	~Interface();

	// Override it!!
	virtual int ExecInterface();

	// Interface signals (interface implementations must override them)
	virtual void OnePasswdLess(char password[BIGGEST_PASSWORD]);
	virtual void FoundPasswd();
	virtual void UserIncorrect();
	virtual void CrackFinished();
	virtual void HostNotFound();
	virtual void ConnectionRefused();
	virtual void TimeOut();
	
	// Say goodbye :-(
	virtual void CouldNotConnect();
								
	protected:
};


class TextInterface: public Interface
{
	public:
	TextInterface();
	~TextInterface();

	int ExecInterface();

	// Interface signals
	void OnePasswdLess(char password[BIGGEST_PASSWORD]);
	void FoundPasswd();
	void UserIncorrect();
	void CrackFinished();
	void HostNotFound();
	void ConnectionRefused();
	void TimeOut();
	void CouldNotConnect();

	private:
	int total;
	int partial;
	
	pthread_mutex_t mutex;
};

#endif

