#include <iostream.h>
#include <vector.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>

#include <PasswdGen.h>
#include <FinalSolution.h>
#include <Debug.h>

#define FIRST_TABLE_ELEMENT 0

char numeric_bf[] = {
	FIRST_TABLE_ELEMENT,
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'
};	


char snumeric_bf[] = {
	FIRST_TABLE_ELEMENT,
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ' '
};	


char alpha_bf[] = {
	FIRST_TABLE_ELEMENT,
	'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
	'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
	'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	' '
};


char alphanumeric_bf[] = {
	FIRST_TABLE_ELEMENT,
	'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm',
	'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z',
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M',
	'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z',
	'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ' '
};


BruteForcePasswdGen::BruteForcePasswdGen(
	int mylength,
	BruteForceRange myrange,
	pwdnum myfirst,
	pwdnum mylast)
	: PasswdGen(myfirst, mylast)
{
	maxlength = mylength;
	range = myrange;
	current = fakecurrent = /*-1*/ 0;

	if(mylast > 0 || myfirst > 0)
	{
		total = mylast - myfirst + 1;
//		current = myfirst;

		char passwd[BIGGEST_PASSWORD];
		pwdnum base;
		char *table;

		switch(range)
		{
			case numeric:
			base = sizeof(numeric_bf);
			table = numeric_bf;
			break;

			case snumeric:
			base = sizeof(snumeric_bf);
			table = snumeric_bf;
			break;

			case alpha:
			base = sizeof(alpha_bf);
			table = alpha_bf;
			break;

			case alphanumeric:
			base = sizeof(alphanumeric_bf);
			table = alphanumeric_bf;
			break;
		}

		vector<pwdnum> rem;
		pwdnumdiv_t d;

		makestring:
		debug("fakecurrent calculation loop");
		fakecurrent++;
		d.quot = fakecurrent;

		for(;;)
		{
			d = pwdnumdiv(d.quot, base);
			rem.push_back(d.rem);
			if(d.quot == 0) break;
		}

		int i;

		for(i=rem.size()-1; i>-1; i--)
		{
			//strncat(passwd, &table[rem[i]], 1);
			if(rem[i] == 0)
			{
				rem.clear();
				//strcpy(passwd, "");
				goto makestring;
			}
		}

		current++;
		if(current != myfirst) goto makestring;
		fakecurrent--;
		current--;
		debug("NOW FAKECURRENT IS " << fakecurrent);
		debug("NOW CURRENT IS " << current);
	
	}
	else
	{
		switch(range)
		{
			case numeric:
			total = (pwdnum)pow(sizeof(numeric_bf) - 1, (double)maxlength);
			faketotal = (pwdnum)pow(sizeof(numeric_bf), (double)maxlength);
//			cout << "numeric" << endl;
			break;

			case snumeric:
			total = (pwdnum)pow(sizeof(snumeric_bf) - 1, (double)maxlength);
			faketotal = (pwdnum)pow(sizeof(snumeric_bf), (double)maxlength);
//			cout << "snumeric" << endl;
			break;
		
			case alpha:
			total = (pwdnum)pow(sizeof(alpha_bf) - 1, (double)maxlength);
			faketotal = (pwdnum)pow(sizeof(alpha_bf), (double)maxlength);
//			cout << "alpha" << endl;
			break;
		
			case alphanumeric:
			total = (pwdnum)pow(sizeof(alphanumeric_bf) - 1, (double)maxlength);
			faketotal = (pwdnum)pow(sizeof(alphanumeric_bf), (double)maxlength);
//			cout << "alphanumeric" << endl;
			break;

//			default:
//			cout << "*** DOH!!! This should never happen :^( ***" << endl;
//			break;
		}
	}

	debug("Bruteforce: " << total << " passwords...")
}


BruteForcePasswdGen::~BruteForcePasswdGen()
{
}


char *BruteForcePasswdGen::Type()
{
	return "Bruteforce";
}


pwdnum BruteForcePasswdGen::TotalPasswds()
{
	return total;
}


void BruteForcePasswdGen::NextPasswd(
	char passwd[BIGGEST_PASSWORD],
	bool *nomorepasswds)
{
/*	cout << "last: " << last << endl;
	cout << "current: " << current << endl;
	cout << "total: " << total << endl;*/
	
	// If we are using session files
	if(last < 0 && current > total)
	{
		*nomorepasswds = true;
		return;
	}

	// If we aren't using session files
	else if(last >= 0 && current > last)
	{
		*nomorepasswds = true;
		return;
	}

	current++;
	*nomorepasswds = false;

	pwdnum base;
	char *table;

	switch(range)
	{
		case numeric:
		base = sizeof(numeric_bf);
		table = numeric_bf;
		break;

		case snumeric:
		base = sizeof(snumeric_bf);
		table = snumeric_bf;
		break;

		case alpha:
		base = sizeof(alpha_bf);
		table = alpha_bf;
		break;

		case alphanumeric:
		base = sizeof(alphanumeric_bf);
		table = alphanumeric_bf;
		break;
	}

	vector<pwdnum> rem;
	pwdnumdiv_t d;

	makestring:
	fakecurrent++;
	d.quot = fakecurrent;

	for(;;)
	{
		d = pwdnumdiv(d.quot, base);
		rem.push_back(d.rem);
		if(d.quot == 0) break;
	}

	int i;

	for(i=rem.size()-1; i>-1; i--)
	{
		strncat(passwd, &table[rem[i]], 1);
		if(rem[i] == 0)
		{
			rem.clear();
			strcpy(passwd, "");
			goto makestring;
		}
	}

	debug("Bruteforce: current password: " << passwd << ". " 
		<< current << " of " << total << " passwords")
}


int BruteForcePasswdGen::MaxLength()
{
	return maxlength;
}

BruteForceRange BruteForcePasswdGen::Range()
{
	return range;
}

