#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <iostream.h>

#include <Protocol.h>
#include <Constants.h>
#include <FinalSolution.h>


FTPProtocolChecker::FTPProtocolChecker()
{
	pthread_mutex_init(&mutex, NULL);
}


FTPProtocolChecker::~FTPProtocolChecker()
{
}


ConnectionResult FTPProtocolChecker::Try(char password[BIGGEST_PASSWORD])
{
	if(!GetFinalSolution()->hostchecked)
	{
		pthread_mutex_lock(&mutex);
		
		if((GetFinalSolution()->h = gethostbyname(params->host)) == NULL)
		{
			return HostNotFound;	
		}

		GetFinalSolution()->hostchecked = true;
		
		pthread_mutex_unlock(&mutex);
	}

	//h->h_addr;

	struct hostent *h = GetFinalSolution()->h;
	
	int sock;
	struct sockaddr_in addr;
	
	sock = socket(AF_INET, SOCK_STREAM, 0);

	addr.sin_family = AF_INET;
	addr.sin_port = htons(params->port);
	addr.sin_addr.s_addr = *((in_addr_t *) h->h_addr);
	memset(&addr.sin_zero, '\0', 8);
	if(connect(sock, (sockaddr *)&addr, sizeof(struct sockaddr)) == -1)
	{
		return ConnectionRefused;
	}

	char buffer[BUFFER_SIZE];
	
	// welcome message
	memset(buffer, '\0', BUFFER_SIZE);
	recv(sock, buffer, BUFFER_SIZE, 0);
	if(strncmp(buffer, "220", 3) != 0)
	{
		shutdown(sock, 2);
		close(sock);
		return ConnectionRefused; 
	}

	// write buffer
	char wbuffer[FTP_BIGGEST_USER + 5];

	// USER command
	memset(wbuffer, 0, FTP_BIGGEST_USER + 5);
	strcpy(wbuffer, "USER ");
	strncat(wbuffer, ((FTPProtocolParams *)(params))->user, FTP_BIGGEST_USER);
	strncat(wbuffer, "\n", 1);

	send(sock, wbuffer, strlen(wbuffer), 0);
	// waiting for user name ok
	memset(buffer, '\0', BUFFER_SIZE);
	recv(sock, buffer, BUFFER_SIZE, 0);
	if(strncmp(buffer, "331", 3) != 0)
	{
		shutdown(sock, 2);
		close(sock);
//		printf("jusuario incorrecto: \"%s\"\n", buffer);
		return UserIncorrect; 
	}

	// PASS command
	memset(wbuffer, 0, FTP_BIGGEST_USER + 5);
	strcpy(wbuffer, "PASS ");
	strncat(wbuffer, password, BIGGEST_PASSWORD);
	strncat(wbuffer, "\n", 1);

	send(sock, wbuffer, strlen(wbuffer), 0);

	// login
	memset(buffer, '\0', BUFFER_SIZE);
	recv(sock, buffer, BUFFER_SIZE, 0);

	if(strncmp(buffer, "230", 3) == 0)
	{
		shutdown(sock, 2);
		close(sock);
		return Login; 
	} else
	{
		shutdown(sock, 2);
		close(sock);
		return PasswordIncorrect;
	}

	shutdown(sock, 2);
	close(sock);
}

