#include <fstream>

#include <Session.h>

using namespace std;

Session::Session()
{
}


Session::~Session()
{
}


bool Session::Read(char *myfilename)
{
	SessionFile_header header;
	ifstream in(myfilename, ios::binary);

	if(!in.is_open()) return false;

	in.read((char*)&header, sizeof(SessionFile_header));
	if(strcmp(header.magicbytes, MAGICBYTES) != 0) return false;
	if(header.version != VERSION_0_2) return false;

	in.read((char*)&data, sizeof(SessionFile_body));

	if(data.method == METHOD_BF)
	{
		in.read((char*)&bfparams, sizeof(SessionFile_bfparams));
	}

	in.close();
	return true;
}


bool Session::Write(char *myfilename)
{
	SessionFile_header header;
	ofstream out(myfilename, ios::binary);
	if(!out.is_open()) return false;

	strcpy(header.magicbytes, MAGICBYTES);
	header.version = VERSION_0_2;

	out.write((char*)&header, sizeof(SessionFile_header));
	out.write((char*)&data, sizeof(SessionFile_body));

	if(data.method == METHOD_BF)
	{
		out.write((char*)&bfparams, sizeof(SessionFile_bfparams));
	}

	out.close();
	return true;
}

