#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <string>

#include <Debug.h>
#include <FinalSolution.h>
#include <Session.h>

#define args	argc - 1

void propaganda()
{
	cout << endl << "FinalSolution v" << VERSION << endl;
	cout << "(C) 2003 by Leandro Ezequiel Lovisolo <lovisolo@datafull.com>" << endl;
	cout << "Published under the terms of the GNU General Public License." << endl;
	cout << "This is free software. Copy it and share it!!" << endl << endl;
}


void helpmessage()
{
	propaganda();

	char a[] =
	"Usage:\n"
	"finalsolution -s <session file> <threads>\n\n"
	"finalsolution -w <file prefix> <sessions number>\n"
	"              <host> <port> <protocol> <protocol params>\n"
	"              <crack mode> <crack params>\n\n"
	"finalsolution <host> <port> <protocol> <protocol params> <threads>\n"
	"              <crack mode> <crack params>\n\n"
	"Where:\n\n"
	"-s <session file>  load the configuration from <session file> (use this\n"
	"                   for distributed cracking)\n"
	"-w <file prefix>   write <sessions number> session files using the\n"
	"                   <file prefix> prefix\n"
	"<sessions number>  number of session files to be created (use with -w)\n"
	"<threads>          is the maximun simultaneous connections number\n\n"
	"<host>             is the host to crack\n"
	"<port>             is the port where the <protocol> is running\n"
	"<protocol>         is the protocol to be cracked\n"
	"<protocol params>  are the protocol specific parameters\n"
	"<threads>          is the maximun simultaneous connections number\n"
	"<crack mode>       is the crack method. it must be one of `bf' (bruteforce)\n"
	"                   or `dict' (dictionary)\n"
	"<crack params>     are the specific parameters for the selected crack method.\n\n"
	"Parameters for the bf crack mode:\n"
	"<max lenght>       is the maximun password length\n"
	"<range>            is the bruteforce range, either `numeric`, `snumeric`,\n"
	"                   `alpha` or `alphanumeric`\n\n"
	"Parameters for the dict crack mode:\n"
	"<file>             is the dictionary to use during the crack\n\n"
	"Supported protocols and protocol parameters:\n"
	"FTP:\n"
	"<username>         is the username to crack\n\n"
	"About the session files prefix:\n"
	"if the prefix is \"microsoft\" and the session files number is 3, you\n"
	"will get three session files: microsoft.1_of_3.fs, microsoft.2_of_3.fs\n"
	"and microsoft.3_of_3.fs\n\n"
	"Example 1 (cracking from a single computer):\n"
	"finalsolution ftp.microsoft.com 21 FTP admin 50 bf 6 alpha\n\n"
	"Example 2 (creating session files for distributed cracking):\n"
	"finalsolution -w microsoft 8 ftp.microsoft.com 21 FTP admin bf 6 alpha\n\n"
	"Example 3 (distributed cracking using session files):\n"
	"finalsolution -s microsoft.1_of_8.fs 50\n\n";

	cout << a;
}


int main(int argc, char *argv[])
{
	FinalSolution fs;
	PasswdGen *pwg;

	//session file params
	char *sessionfile;
	int filesnumber;
	enum {s_read, s_write} session_task;
	bool use_sessions = false;

	//general params:
	char *host;
	int port;
	char *proto;
	int threads;
	char *crack;
	
	//bruteforce params:
	int bf_maxlength;
	BruteForceRange range;

	//dictionary params:
	char *dict_file;
	
	//ftp params:
	char *ftp_username;

	//pop3 params:
	char *pop3_username;
	
	//the looong and boring commandline parser...

	if(args<1)
	{
		helpmessage();
		return 0;
	}

	int p = 0;
	string s;

	s = argv[p+1];
	if(s == "-w")
	{
		if(args<p+3)
		{
			helpmessage();
			return 0;
		}

		sessionfile = argv[p+2];
		filesnumber = atoi(argv[p+3]);

		session_task = s_write;
		use_sessions = true;

		p += 3;
	}
	
	else if(s == "-s")
	{
		if(args<p+3)
		{
			helpmessage();
			return 0;
		}

		sessionfile = argv[p+2];
		threads = atoi(argv[p+3]);

		session_task = s_read;
		use_sessions = true;

		p+=3;

		goto the_end;
	}

	if(args<p+3)
	{
		helpmessage();
		return 0;
	}

	host = argv[p+1];
	port = atoi(argv[p+2]);
	proto = argv[p+3];

	p += 3;

	if(strcmp(proto, "FTP") == 0)
	{
		if(args<p+1)
		{
			helpmessage();
			return 0;
		}

		ftp_username=argv[p+1];
		p++;
	} else
	if(strcmp(proto, "POP3") == 0)
	{
		cout << "Sorry, currently only FTP protocol is supported." << endl;
		return 0;
		
		if(args<p+1)
		{
			helpmessage();
			return 0;
		}

		pop3_username=argv[p+1];
		p++;
	} else
	{
		helpmessage();
		return 0;
	}

	if(!use_sessions)
	{
		if(args<p+1)
		{
			helpmessage();
			return 0;
		}

		threads = atoi(argv[p+1]);
		p++;
	}
	
	if(args<p+1)
	{
		helpmessage();
		return 0;
	}

	crack = argv[p+1];
	p++;

	if(strcmp(crack, "bf") == 0)
	{
		if(args<p+1)
		{
			helpmessage();
			return 0;
		}

		bf_maxlength = atoi(argv[p+1]);
		p++;

		if(args<p+1)
		{
			helpmessage();
			return 0;
		}

		if(strcmp(argv[p+1], "numeric") == 0)
		{
			range = numeric;
		} else
		if(strcmp(argv[p+1], "snumeric") == 0)
		{
			range = snumeric;
		} else
		if(strcmp(argv[p+1], "alpha") == 0)
		{
			range = alpha;
		} else
		if(strcmp(argv[p+1], "alphanumeric") == 0)
		{
			range = alphanumeric;
		} else
		{
			helpmessage();
			return(0);
		}

		p++;		
	} else
	if(strcmp(crack, "dict") == 0)
	{
		cout << "Sorry, currently only Bruteforce mode is supported." << endl;
		return 0;
		
		if(args<p+1)
		{
			helpmessage();
			return 0;
		}

		dict_file = argv[p+1];
		p++;
	} else
	{
		helpmessage();
		return 0;
	}
	//ready!


	the_end:
	//now print some info and setup everything
	propaganda();

	if(strcmp(crack, "bf") == 0)
	{
		pwg = new BruteForcePasswdGen(bf_maxlength, range, (pwdnum)-1, (pwdnum)-1);
	}

	if(strcmp(crack, "dict") == 0)
	{
		pwg = new DictionaryPasswdGen(dict_file, (pwdnum)-1, (pwdnum)-1);
	}

	if(use_sessions)
	{
		if(session_task == s_read)
		{
			//
			// THIS IS THE READER OF SESSION FILES
			//
		
			Session mysession;

			if(!mysession.Read(sessionfile))
			{
				cout << "Couldn't read " << sessionfile << "!" << endl;
				exit(0);
			}

			Protocol protocol;
			ProtocolParams *params;


			if(mysession.data.protocol == PROTOCOL_FTP)
			{
				protocol = FTP;
				params = new FTPProtocolParams();
				strncpy(
					((FTPProtocolParams *)(params))->user,
					mysession.data.user,
					FTP_BIGGEST_USER);
			}

			else if(mysession.data.protocol == PROTOCOL_POP3)
			{
				protocol = POP3;
				params = new ProtocolParams();
			}

			else
			{
				cout << "Session file corrupted." << endl;
					exit(0);
			}

			strncpy(params->host, mysession.data.host, HOST_LENGTH); 
			params->port = mysession.data.port;

			if(mysession.data.method == METHOD_BF)
			{
				if(mysession.bfparams.range == BF_RANGE_NUM) range = numeric;
				if(mysession.bfparams.range == BF_RANGE_ALPHA) range = alpha;
				if(mysession.bfparams.range == BF_RANGE_ALPHAN) range = alphanumeric;
				
				pwg = new BruteForcePasswdGen(
					mysession.bfparams.maxlength,
					range,
					mysession.data.range[0],
					mysession.data.range[1]);
			}

			if(mysession.data.method == METHOD_DICT)
			{
				pwg = new DictionaryPasswdGen(
					dict_file,
					mysession.data.range[0],
					mysession.data.range[1]);
			}

			SetFinalSolution(&fs);
			fs.SetupCrack(protocol, params, pwg, threads);
			fs.StartCrack();

			exit(0);
		}
		
		if(session_task == s_write)
		{
			//
			// THIS IS THE WRITER OF SESSION FILES
			//

			if(filesnumber <= 0 || filesnumber == 1)
			{
				cout << "Please enter a valid session files number" << endl;
				exit(0);
			}

			if(filesnumber > pwg->TotalPasswds())
			{
				cout << "The session files number is bigger than the passwords number, which is " << pwg->TotalPasswds() << endl;
				exit(0);
			}

			Session mysession;

			strncpy(mysession.data.host, host, HOST_LENGTH);
			mysession.data.port = port;

			s = "FTP";
			if(s==proto)
			{
				mysession.data.protocol = PROTOCOL_FTP;
				strncpy(mysession.data.user, ftp_username, FTP_BIGGEST_USER);
			}
		
			else
			{
				s = "POP3";
				if(s==proto)
				{
					mysession.data.protocol = PROTOCOL_POP3;
					strncpy(mysession.data.user, pop3_username, POP3_BIGGEST_USER);
				}
			}

			s = "bf";
			if(s==crack)
			{
				mysession.data.method = METHOD_BF;

				if(range == numeric) mysession.bfparams.range = BF_RANGE_NUM;
				if(range == alpha) mysession.bfparams.range = BF_RANGE_ALPHA;
				if(range == alphanumeric) mysession.bfparams.range = BF_RANGE_ALPHAN;

				mysession.bfparams.maxlength = bf_maxlength;
			}
			else
			{
				s = "dict";
				if(s==crack) mysession.data.method = METHOD_DICT;
			}

			int i;
			pwdnumdiv_t d = pwdnumdiv(pwg->TotalPasswds(), filesnumber);
	
			pwdnum lastpasswd = -1;

//			cout << "TotalPasswds / filesnumber " << pwg->TotalPasswds() << "; " << filesnumber << endl;
//			cout << "d.quot / d.rem " << d.quot << "; " << d.rem << endl;

			for(i=0; i<filesnumber; i++)
			{
/*				if(lastpasswd == -1) mysession.data.range[0] = 0;
				else mysession.data.range[0] = lastpasswd + 1;
				if(lastpasswd == -1) lastpasswd = mysession.data.range[1] = lastpasswd + 1 + d.quot;
				else lastpasswd = mysession.data.range[1] = lastpasswd + d.quot;
				if(i == filesnumber - 1) mysession.data.range[1] += d.rem;*/
				
				if(lastpasswd == -1) mysession.data.range[0] = 1;
				else mysession.data.range[0] = lastpasswd + 1;
				if(lastpasswd == -1) lastpasswd = mysession.data.range[1] = lastpasswd + 1 + d.quot;
				else lastpasswd = mysession.data.range[1] = lastpasswd + d.quot;
				if(i == filesnumber - 1) mysession.data.range[1] += d.rem;


				debug("Begin: " << mysession.data.range[0] << " End: " << mysession.data.range[1]);

				char filename[1024];
				sprintf(filename, "%s.%d_of_%d.fs", sessionfile, (i + 1), filesnumber);

				cout << "Writing " << filename << " | Range: " <<
					mysession.data.range[0] << " to " << mysession.data.range[1] << endl;

				if(!mysession.Write(filename))
				{
					cout << "Couldn't write " << filename << "!" << endl;
					exit(0);
				}
			}

			cout << endl << "Session files created" << endl;
			exit(0);
		}
	}

	Protocol protocol;
	ProtocolParams *params;


	if(strcmp(proto, "FTP") == 0)
	{
		protocol = FTP;
		params = new FTPProtocolParams();
		strncpy(
			((FTPProtocolParams *)(params))->user,
			ftp_username,
			FTP_BIGGEST_USER);
	}

	if(strcmp(proto, "POP3") == 0)
	{
		protocol = POP3;
		params = new ProtocolParams();
	}

	strncpy(params->host, host, HOST_LENGTH); 
	params->port = port;

	SetFinalSolution(&fs);
	fs.SetupCrack(protocol, params, pwg, threads);
	fs.StartCrack();

	return 0;
}

